//
//  AsReaderP252BManager.h
//  AsReaderLR
//
//  Created by iOS on 15.6.21.
//  Copyright © 2021 asterisk. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AsReaderP252BSDK/AsReaderP252BSDK.h>
typedef enum {
    AsReaderP252BSettingRFIDType_Set,
    AsReaderP252BSettingRFIDType_Seted,
    AsReaderP252BSettingRFIDType_UnSet,
} AsReaderP252BSettingRFIDType;

@protocol AsReaderP252BManagerDelegate <NSObject>
@optional
- (void)didDiscoverAsReaderP252BDeviceList:(NSArray<AsReaderP252B *> *)bluetoothDeviceList;
- (void)didUpdateBluetoothState:(BOOL)stasus;

- (void)whenAsReaderP252BIsConnected:(BOOL)isConnected;
- (void)updateAsReaderP252BDeviceState:(AsReaderP252BResultCode)error;
- (void)readAsReaderP252BTag:(NSString *)tag rssi:(float)rssi phase:(float)phase frequency:(float)frequency;
- (void)changedAsReaderP252BActionState:(AsReaderP252BCommandType)action resultCode:(NSInteger)resultCode;

- (void)accessAsReaderP252BResult:(AsReaderP252BResultCode)error actionState:(AsReaderP252BCommandType)action epc:(NSString *)epc data:(NSString *)data rssi:(float)rssi phase:(float)phase frequency:(float)frequency;
- (void)readAsReaderP252BTemperatureTag:(NSString *)tag rssi:(float)rssi phase:(float)phase frequency:(float)frequency temperature:(float)temperature;
- (void)readAsReaderP252BHumidityTag:(NSString *)tag rssi:(float)rssi phase:(float)phase frequency:(float)frequency humidity:(float)humidity;

- (BOOL)onAsReaderP252BTriggerKeyEvent:(BOOL)status;
- (BOOL)onAsReaderP252BModeKeyEvent:(BOOL)status;
- (void)whenAsReaderP252BReceivedData:(NSData *)receivedData;
- (void)whenAsReaderP252BWriteData:(NSData *)writeData;
- (void)detectBarcode:(AsReaderP252BBarcodeType)barcodeType barcode:(NSString *)barcode;
- (void)detectBarcode:(AsReaderP252BBarcodeType)barcodeType barcodeData:(NSData *)barcodeData;
@end
 

@interface AsReaderP252BManager : NSObject
@property (nonatomic, strong) id<AsReaderP252BManagerDelegate>delegate;
@property (nonatomic, strong, readonly) AsReaderP252B *asReaderP252B;
@property (nonatomic, assign) AsReaderP252BSettingRFIDType settingRFIDType;

+ (AsReaderP252BManager *)sharedAsReaderP252BManager;

- (void)startDiscovered;
- (void)stopDiscovered;
- (void)connectWithAsReader:(AsReaderP252B *)asraeder;

@end
 
