//
//  ShowLogView.m
//  AsReaderLR
//
//  Created by iOS on 18.6.21.
//  Copyright © 2021 asterisk. All rights reserved.
//

#import "ShowLogView.h"
#import <UIKit/UIKit.h>
@implementation ShowLogView{
    UIButton            *logButton;
    UIButton            *backButton;
    UITextView          *logTextView;
    UIButton            *clearButton;
    NSMutableString     *textString;
    UIWindow            *window;
    BOOL                isShowText;
    NSDateFormatter     *dateFormatter;
}
#define USED_SHOWLOG 0

static ShowLogView *_sharedShowLogView = nil;
+ (ShowLogView *)sharedShowLogView{
    if (!_sharedShowLogView) {
        _sharedShowLogView = [[ShowLogView alloc] init];
    }
    return _sharedShowLogView;
}
- (instancetype)init
{
    self = [super init];
    if (self) {
        textString = [[NSMutableString alloc] init];
        logButton = [UIButton buttonWithType:UIButtonTypeCustom];
        logButton.frame = CGRectMake([UIScreen mainScreen].bounds.size.width - 70, [UIScreen mainScreen].bounds.size.height - 300, 50, 50);
        [logButton setTitle:@"Log" forState:UIControlStateNormal];
        [logButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        logButton.layer.masksToBounds = YES;
        logButton.layer.cornerRadius = logButton.frame.size.width / 2;
        logButton.backgroundColor = [UIColor orangeColor];
        [logButton addTarget:self action:@selector(dragMoving:withEvent:)forControlEvents: UIControlEventTouchDragInside];
        [logButton addTarget:self action:@selector(dragEnded:withEvent:)forControlEvents:UIControlEventTouchUpOutside];
        [logButton addTarget:self action:@selector(buttonAction:) forControlEvents:(UIControlEventTouchUpInside)];
        
        backButton = [[UIButton alloc] initWithFrame:CGRectMake(0, [UIScreen mainScreen].bounds.size.height - 220, [UIScreen mainScreen].bounds.size.width, 220)];
        backButton.backgroundColor = [UIColor grayColor];
        backButton.hidden = YES;
        
        logTextView = [[UITextView alloc] initWithFrame:CGRectMake(5, 5, backButton.frame.size.width - 10, 170)];
        logTextView.editable = NO;
        logTextView.layer.masksToBounds = YES;
        logTextView.layer.borderWidth = 1;
        logTextView.layer.borderColor = [[UIColor lightGrayColor] CGColor];
        logTextView.layer.cornerRadius = 10;
        [backButton addSubview:logTextView];
        
        clearButton = [UIButton buttonWithType:UIButtonTypeCustom];
        clearButton.frame = CGRectMake(backButton.frame.size.width - 70, backButton.frame.size.height - 35, 60, 30);
        [clearButton setTitle:@"Clear" forState:UIControlStateNormal];
        clearButton.titleLabel.font = [UIFont systemFontOfSize:15];
        clearButton.layer.masksToBounds = YES;
        clearButton.layer.cornerRadius = 5;
        [clearButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        clearButton.backgroundColor = [UIColor lightGrayColor];
        [clearButton addTarget:self action:@selector(clearAction) forControlEvents:(UIControlEventTouchUpInside)];
        [backButton addSubview:clearButton];
        [backButton addTarget:self action:@selector(dragMoving:withEvent:)forControlEvents: UIControlEventTouchDragInside];
        [backButton addTarget:self action:@selector(dragEnded:withEvent:)forControlEvents:UIControlEventTouchUpOutside];
        dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@" [YYYY-MM-dd HH:mm:ss:SSS] \n"];
    }
    return self;
}
- (void)buttonAction:(UIControl *)c {
    backButton.hidden = !backButton.isHidden;
    isShowText = !backButton.isHidden;
    if (isShowText) {
        logTextView.text = textString;
    }
}
- (void)showView:(BOOL)isShow{
    if (USED_SHOWLOG == 0) {
        return;
    }
    if (isShow) {
        window = [UIApplication sharedApplication].keyWindow;
        [window addSubview:backButton];
        [window addSubview:logButton];
    }else{
        [logButton removeFromSuperview];
        [backButton removeFromSuperview];
    }
}
- (void)addData:(NSData *)data isInput:(BOOL)isInput{
    if (USED_SHOWLOG == 0) {
        return;
    }
    NSMutableString* dataString = [[NSMutableString alloc] init];
//    [dataString appendString:[self dateToString]];
    unsigned char* ptr= (unsigned char*) [data bytes];
    for(int i = 0; i < data.length; i++)
        [dataString appendFormat:@"%02X ", *ptr++ & 0xFF ];
    [self addText:dataString isInput:isInput];
}
- (NSString *)dateToString{
    NSDate *currentDate = [NSDate date];
    NSString *currentDateString = [dateFormatter stringFromDate:currentDate];
    return currentDateString;
}
- (void)addText:(NSString *)String isInput:(BOOL)isInput{
    if (USED_SHOWLOG == 0) {
        return;
    }
    NSString * str = @"";
    if (isInput) {
        if (textString.length == 0) {
            str = [@"RX:" stringByAppendingString:String];
        }else{
            str = [@"\nRX:" stringByAppendingString:String];
        }
    }else{
        if (textString.length == 0) {
            str = [@"TX:" stringByAppendingString:String];
        }else{
            str = [@"\nTX:" stringByAppendingString:String];
        }
    }
    [textString appendString:str];
    if (isShowText) {
        logTextView.text = textString;
    }
}
- (void)clearAction{
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        self->textString = [[NSMutableString alloc] init];
        self->logTextView.text = self->textString;
    }];
}
- (void)dragMoving:(UIControl *)c withEvent:ev {
    c.center = [[[ev allTouches] anyObject] locationInView:window];
}
- (void)dragEnded:(UIControl *)c withEvent:ev {
    c.center = [[[ev allTouches] anyObject] locationInView:window];
}
@end
